/// PersefoneDesktop - a GUI to the Persefone model of agriculture and ecosystems
///
/// This file creates the splash screen. Load it using a QQuickView.
///

import QtQuick
import QtQuick.Controls
import org.julialang

Popup {
	id: splashPopupExt
	parent: Overlay.overlay

	width: 600
	height: 250

	x: Math.round((parent.width - width) / 2)
    y: Math.round((parent.height - height) / 2)

	Rectangle {
		anchors.fill: parent
		
		Image {
			source: "persefonejl_logo_v3_splash.png"
			fillMode: Image.Stretch
		}
		Timer {
			// Show the splash screen while the model object is initialised
			//XXX is 15s a good time here?
			interval: 15000; running: true; repeat: false
			onTriggered: parent.Window.window.close()
		}
	}
}
